package gov.va.med.mhv.admin.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import gov.va.med.mhv.common.data.model.FacilityInfo;

@Entity
@Table(name = "ORG")
public class Org implements Serializable {

	public FacilityInfo getFacilityInfo() {
		return facilityInfo;
	}

	public void setFacilityInfo(FacilityInfo facilityInfo) {
		this.facilityInfo = facilityInfo;
	}

	private static final long serialVersionUID = -5988029358352289682L;

	@Id
	@Column(name = "ORG_ID")
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@Column(name = "OPLOCK")
	private Integer oplock;

	@Column(name = "ORG_TYPE")
	private String typeOfOrganization;

	@Column(name = "NAME")
	private String name;

	@Column(name = "PARENT_ORG_ID")
	private Long parentOrganization;

	// @ManyToOne
	@Column(name = "FACILITY_INFO_ID")
	private Long facilityInfoId;
	
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "FACILITY_INFO_ID", insertable = false, updatable = false)
	private FacilityInfo facilityInfo;	

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Integer getOplock() {
		return oplock;
	}

	public void setOplock(Integer oplock) {
		this.oplock = oplock;
	}

	public String getTypeOfOrganization() {
		return typeOfOrganization;
	}

	public void setTypeOfOrganization(String typeOfOrganization) {
		this.typeOfOrganization = typeOfOrganization;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getParentOrganization() {
		return parentOrganization;
	}

	public void setParentOrganization(Long parentOrganization) {
		this.parentOrganization = parentOrganization;
	}

	public Long getFacilityInfoId() {
		return facilityInfoId;
	}

	public void setFacilityInfoId(Long facilityInfoId) {
		this.facilityInfoId = facilityInfoId;
	}

}
