package gov.va.med.mhv.admin.service.impl.calendar;

import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import gov.va.med.mhv.admin.converter.ApiCategoryConverter;
import gov.va.med.mhv.admin.dto.ApiCategoryDTO;
import gov.va.med.mhv.admin.model.ApiCategory;
import gov.va.med.mhv.admin.repository.ApiCategoryRepository;
import gov.va.med.mhv.admin.service.calendar.ApiCategoryService;
import gov.va.med.mhv.common.api.exception.MHVException;

@Path("/")
@Service("apiCategoryService")
@Component
public class ApiCategoryServiceImpl implements ApiCategoryService {
	private static Logger log = LogManager.getLogger(ApiCategoryServiceImpl.class);

	@Autowired
	private ApiCategoryRepository apiCategoryRepository;

	@GET
	@Produces(MediaType.APPLICATION_JSON)
	@Path("/calcviewapicategoryapicats")
	@Override
	public List<ApiCategoryDTO> getApiCats() throws MHVException {
		List<ApiCategoryDTO> apiCatsDtos = null;
		List<ApiCategory> apiCats = null;

		try {
			apiCats = apiCategoryRepository.getApiCats();
		} catch (Exception e) {
			log.error("Error in fetching all api categories " + e);
			throw new MHVException(e);
		}

		if (apiCats == null || apiCats.size() == 0) {
			apiCats = new ArrayList<ApiCategory>();
		} else {
			apiCatsDtos = new ApiCategoryConverter().convert(apiCats);
		}

		return apiCatsDtos;
	}

}
