package gov.va.med.mhv.admin.service.impl.calendar;

import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import gov.va.med.mhv.admin.converter.UserCalCatConverter;
import gov.va.med.mhv.admin.dto.UserCalCatDTO;
import gov.va.med.mhv.admin.model.UserCalCat;
import gov.va.med.mhv.admin.repository.UserCalCatRepository;
import gov.va.med.mhv.admin.service.calendar.UserCalCatService;
import gov.va.med.mhv.common.api.exception.MHVException;

@Path("/")
@Service("userCalCatService")
@Component
public class UserCalCatServiceImpl implements UserCalCatService {
	private static Logger log = LogManager.getLogger(UserCalCatServiceImpl.class);

	@Autowired
	private UserCalCatRepository userCalCatRepository;

	@Override
	@GET
	@Produces(MediaType.APPLICATION_JSON)
	@Path("/getUserCalCatsForUser/{userProfileId}")
	public List<UserCalCatDTO> getUserCalCatsForUser(@PathParam("userProfileId") Long userProfileId)
			throws MHVException {
		List<UserCalCatDTO> userCalCatDtos = null;
		List<UserCalCat> userCalCats = null;

		try {
			userCalCats = userCalCatRepository.getUserCalCatsForUserProfileId(userProfileId);
		} catch (Exception e) {
			log.error("Error in fetching UserCalCatsForView " + e);
			throw new MHVException(e);
		}

		if (userCalCats == null || userCalCats.size() == 0) {
			userCalCats = new ArrayList<UserCalCat>();
		}

		userCalCatDtos = new UserCalCatConverter().convert(userCalCats);

		return userCalCatDtos;
	}

}
